<template>
  <a-page-header :title="getPageTitle()" @back="() => $router.go(-1)">
    <template #extra>
      <Extra/>
    </template>
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="dormitoryBedId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a @click="openEdit(record)">修改</a>
                <a-divider type="vertical" />
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a class="ele-text-danger">删除</a>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <DormitoryBedEdit v-model:visible="showEdit" :data="current" @done="reload" />
  </a-page-header>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import DormitoryBedEdit from './components/dormitoryBedEdit.vue';
  import { pageDormitoryBed, removeDormitoryBed, removeBatchDormitoryBed } from '@/api/dormitory/dormitoryBed';
  import type { DormitoryBed, DormitoryBedParam } from '@/api/dormitory/dormitoryBed/model';
  import {getPageTitle} from "@/utils/common";
  import Extra from "@/views/dormitory/Extra.vue";

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<DormitoryBed[]>([]);
  // 当前编辑数据
  const current = ref<DormitoryBed | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageDormitoryBed({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '床铺ID',
      dataIndex: 'id',
      key: 'userId',
      align: 'center',
      width: 120
    },
    {
      title: '床铺编号',
      dataIndex: 'name',
      key: 'name',
      align: 'center',
    },
    {
      title: '学生姓名',
      dataIndex: 'realName',
      key: 'realName',
      align: 'center',
      width: 300,
    },
    // {
    //   title: '手机号码',
    //   dataIndex: 'phone',
    //   key: 'phone',
    //   align: 'center'
    // },
    // {
    //   title: '学号',
    //   dataIndex: 'userId',
    //   key: 'userId',
    //   align: 'center'
    // },
    // {
    //   title: '床铺号',
    //   dataIndex: 'name',
    //   key: 'name',
    //   align: 'center',
    // },
    {
      title: '宿舍号',
      dataIndex: 'recordName',
      key: 'recordName',
      align: 'center',
      width: 300,
    },
    {
      title: '上下铺',
      dataIndex: 'bunk',
      key: 'bunk',
      align: 'center',
      customRender: ({ record }) => {
        return record.bunk === 0 ? '下铺' : '上铺';
      }
    },
    // {
    //   title: '充电口',
    //   dataIndex: 'chargingPort',
    //   key: 'chargingPort',
    //   align: 'center',
    // },
    {
      title: '排序',
      dataIndex: 'sortNumber',
      key: 'sortNumber',
      align: 'center',
    },
    // {
    //   title: '备注',
    //   dataIndex: 'comments',
    //   key: 'comments',
    //   align: 'center',
    // },
    // {
    //   title: '状态',
    //   dataIndex: 'status',
    //   key: 'status',
    //   align: 'center',
    // },
    // {
    //   title: '创建时间',
    //   dataIndex: 'createTime',
    //   key: 'createTime',
    //   align: 'center',
    //   sorter: true,
    //   ellipsis: true,
    //   customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd')
    // },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: DormitoryBedParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: DormitoryBed) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: DormitoryBed) => {
    const hide = message.loading('请求中..', 0);
    removeDormitoryBed(row.id)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchDormitoryBed(selection.value.map((d) => d.id))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: DormitoryBed) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'DormitoryBed'
  };
</script>

<style lang="less" scoped></style>
